
// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "XDbar.h"

#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	ON_WM_CREATE()
	ON_WM_SIZE()
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP | CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}
	m_wndStatusBar.SetIndicators(indicators, sizeof(indicators)/sizeof(UINT));

	// TODO: Delete these three lines if you don't want the toolbar to be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	if (!CreateDlgBar1()) return -1;

	//SetWindowSubclass(); 
	//BOOL SetWindowSubclass(HWND hWnd, SUBCLASSPROC pfnSubclass, UINT_PTR uIDSubclass, DWORD_PTR dwRefData);

	ShowControlBar( &m_wndDlgBar1, TRUE, FALSE );	// show command window

	m_font.CreatePointFont(160, _T("Courier New"), 0);

	m_wndDlgBar1.GetDlgItem(IDC_EDIT_QUERY)->SetFont(&m_font);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return TRUE;
}

BOOL CMainFrame::CreateDlgBar1()
{
	// IDD_CMDBAR - Resource ID of the dialog 
	// template. This dialog template should be created 
	// with  the  style  WS_CHILD and no other style.
	// The template must not have the style WS_VISIBLE.
   
	if (!m_wndDlgBar1.Create(this, IDD_DBAR1,
      CBRS_BOTTOM|CBRS_TOOLTIPS|CBRS_FLYBY, IDD_DBAR1))
	{
		TRACE0("Failed to create DlgBar1\n");
		return -1;      // Fail to create.
	}
	
	// set the font for this window
	//CComboBoxEx * pComboBox = (CComboBoxEx*)m_wndDlgBar1.GetDlgItem(IDC_COMBOBOXEX1);
	//pComboBox->SetFont(&m_font);

	return 1;

}// CreateDlgBar1()

// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}
#endif //_DEBUG


// CMainFrame message handlers


void CMainFrame::OnSize(UINT nType, int cx, int cy)
{
	CFrameWnd::OnSize(nType, cx, cy);

	
	CEdit * pEditBox = NULL;

	if(m_wndDlgBar1)
		pEditBox = (CEdit*)m_wndDlgBar1.GetDlgItem(IDC_EDIT_QUERY);  // avoids crash on boot up

	CRect rb;	// dialog bar rect
	CRect rc;	// edit box rect

	if(m_wndDlgBar1)		// resize the dialog bar edit window if visible
	{
		m_wndDlgBar1.GetWindowRect(&rb);
		m_wndDlgBar1.ScreenToClient(&rb);
		//pEditBox->GetWindowRect(&rc);
		//pEditBox->MoveWindow(rb.left, rb.top, cx-6, rc.Height(), TRUE);
		rb.DeflateRect(3,3);
		pEditBox->MoveWindow(rb.left, rb.top, rb.Width(), rb.Height(), TRUE);
	}

}


BOOL CMainFrame::OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo)
{
	if(m_wndDlgBar1.OnCmdMsg(nID, nCode, pExtra, pHandlerInfo))
	{
		return TRUE;
	}

	return CFrameWnd::OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);
}
